//----------------------------------------------------------------------------

//General control module, header file

//----------------------------------------------------------------------------

#ifndef CONTROL_HPP
#define CONTROL_HPP

//----------------------------------------------------------------------------

#include "systimer.hpp"
#include "display.hpp"
#include "keyboard.hpp"
#include "encoder.hpp"
#include "menu.hpp"

//----------------------------------------------------------------------------
//---------------------------- TControl class: -------------------------------
//----------------------------------------------------------------------------

class TControl
{
private:
  Pin_VCC_t Pin_VCC;
  Pin_PWM_t Pin_PWM;
 TKeyboard *Keyboard;
  TMenuItems *Menu;
  TSoftTimer *MenuTimer;
  TSoftTimer *ExitTimer;
  bool MenuBrief;
  static const uint16_t MENU_BRIEF = 1000;
  static const uint16_t MENU_EXIT = 5000;
//COMMON ANODE:
#ifdef COMMONANODE
  #ifdef REDCOLOR
    static const uint16_t PWM_MIN =  86; //TODO: TBD
    static const uint16_t PWM_MAX = 210; //TODO: TBD
  #endif
  #ifdef GRNCOLOR
    static const uint16_t PWM_MIN = 100; //TODO: TBD
    static const uint16_t PWM_MAX = 210; //TODO: TBD
  #endif
//COMMON CATHODE:
#else
  #ifdef REDCOLOR
    static const uint16_t PWM_MIN =  71; //TODO: TBD
    static const uint16_t PWM_MAX = 181; //TODO: TBD
  #endif
  #ifdef GRNCOLOR
    static const uint16_t PWM_MIN =  83; //TODO: TBD
    static const uint16_t PWM_MAX = 181; //TODO: TBD
  #endif
#endif
  uint8_t MnuIndex;
  uint8_t BackMenu;
  void HardwareInit(void);
  void WatchdogService(void);
  void DataSaveService(void);
  Pin_PB4_t Pin_PB4;
  Pin_PC5_t Pin_PC5;
  //Pin_RXD_t Pin_RXD;
  //Pin_TXD_t Pin_TXD;
  //Pin_DIR_t Pin_DIR;
  Pin_PD5_t Pin_PD5;
public:
  //static const uint8_t BHT_MAX = 99;
  TControl(void);
  void Execute(void);
  void SetBright(uint8_t b);
};

//----------------------------------------------------------------------------

extern TControl *Control;

//----------------------------------------------------------------------------

#endif
